<template>
    <div class="frame">
        <div class="text-center">
            <router-link :to="{ name: 'home' }" class="orange-link">
                <h2 class="high-title">Online Cinema</h2>
            </router-link>
        </div>

        <nav class="navbar navbar-expand-md shadow-sm nav-link">
            <div id="navbarCollapse" class="collapse navbar-collapse">
                <ul class="navbar-nav">
                    <li class="nav-item" @click="sendUserData()">
                        <router-link
                        class="nav-link"
                        data-toggle="collapse"
                        :to="{ name: 'home' }"
                        >
                        Home
                        </router-link>
                    </li>

                    <li class="nav-item" @click="sendUserData()">
                        <router-link
                        class="nav-link"
                        data-toggle="collapse"
                        :to="{ name: 'login' }"
                        >
                        Login
                        </router-link>
                    </li>

                    <li class="nav-item" @click="sendUserData()">
                        <router-link
                        class="nav-link"
                        data-toggle="collapse"
                        :to="{ name: 'register' }"
                        >
                        Registration
                        </router-link>
                    </li>

                    <li class="nav-item" @click="sendUserData()">
                        <router-link
                        class="nav-link"
                        data-toggle="collapse"
                        :to="{ name: 'cabinet' }"
                        >
                        Personal cabinet
                        </router-link>
                    </li>

                    <li class="nav-item" @click="sendUserData()" v-if="showWatchLink()">
                        <router-link
                        class="nav-link"
                        data-toggle="collapse"
                        :to="{ name: 'watch' }"
                        >
                        Watching movies
                        </router-link>
                    </li>

                    <li class="nav-item">
                        <a href="#"
                        class="nav-link"
                        data-toggle="collapse"
                        @click.prevent="logout"
                        >
                        Logout
                        </a>
                    </li>
                </ul>
                <ul class="navbar-nav ml-auto">
                    <li class="nav-item nav-link greeting" v-if="user" >
                        Hello, {{ user.name }}!
                    </li>

                </ul>
            </div>
        </nav>
        <router-view :user='user'></router-view>
    </div>
</template>

<script>
import axios from "axios";
import User from '../src/apis/User';
import eventHub from '../eventHub';
import Api from '../src/apis/Api';
import Login from '../pages/Login.vue';

export default {
    data: function() {
        return {
            seeGreeting: false,
            user: null
        }
    },
    watch: {
        $route() {
            $("#navbarCollapse").collapse("hide");
            this.getUserData();
            //this.sendUserData();
        },
        user: {
            handler: 'checkUserAuth',
            immediate: true
        }
    },
    mounted() {
        // adding eventHub listener
        eventHub.$on('auth-navbar', () => {
            this.getUserData();
        })
    },
    beforeDestroy() {
        // removing eventHub listener
        eventHub.$off('login-navbar')
    },
    methods: {
        logout(evt) {
            if(confirm("Are you sure you want to log out?")) {
                User.logout().then(response => {
                    this.user = null;
                    localStorage.removeItem('token');
                    this.sendUserData();
                    this.$router.push({ name: "login" });
                }
            )
                .catch(error => {
                    localStorage.removeItem('token');

                    this.$router.push({ name: "login" });
                    }
                );
            }
        },
        sendUserData() {
            eventHub.$emit('app-home', this.user);
            eventHub.$emit('app-cabinet', this.user);
            eventHub.$emit('app-watch', this.user);
        },
        isLoggedIn() {
            return !!localStorage.getItem("token");
        },
        getUserData() {
            User.auth().then(response => {
                this.user = response.data;
                //console.log(this.user);
            });
        },
        checkUserAuth() {
            if (!this.user && this.isLoggedIn()) {
                this.getUserData();
            }
            this.sendUserData();
        },
        showWatchLink() {
            if (this.user) {
                if (this.user.access_type == 'subscribed') {
                    return true;
                }
            }
            return false;
        }
    }
};
</script>

<style>
    html, body {
        height: 100%;
    }
    html {
        /*background-color: black;*/
    }
    body {
        margin: 0;
        padding: 0;
        /* min-height: 100%; */
        background-image: url('../../images/main-background.jpg');
        background-color: #cccccc;
        background-repeat: no-repeat;
        background-size: cover;
        /*text-align: center;*/
    }
    .frame {
        width: 70%;
        height: 100%;
        display: table;
        background-color: black;
        margin-left: auto;
        margin-right: auto;
    }
    .navbar {
        width: 100%;
    }
    .navbar-collapse {
        justify-content: space-between;

    }
    .greeting {
        color: orange;
    }
    .show {
        display: inline-block;
    }
    .high-title {
        padding-top: 5px;
    }
    .text-center {
        margin-left: auto;
        margin-right: auto;
    }
    a.orange-link, a.nav-link {
        color: orange;
         display: inline-block;
    }
    a.nav-link:checked, a.nav-link:focus {
        color:greenyellow;
    }

    .nav-link:hover, .orange-link:hover {
        color: crimson;
    }

</style>
